/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	v1 "k8s.io/api/rbac/v1"
)

// UserInfoApplyConfiguration represents an declarative configuration of the UserInfo type for use
// with apply.
type UserInfoApplyConfiguration struct {
	Roles        []string     `json:"roles,omitempty"`
	ClusterRoles []string     `json:"clusterRoles,omitempty"`
	Subjects     []v1.Subject `json:"subjects,omitempty"`
}

// UserInfoApplyConfiguration constructs an declarative configuration of the UserInfo type for use with
// apply.
func UserInfo() *UserInfoApplyConfiguration {
	return &UserInfoApplyConfiguration{}
}

// WithRoles adds the given value to the Roles field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Roles field.
func (b *UserInfoApplyConfiguration) WithRoles(values ...string) *UserInfoApplyConfiguration {
	for i := range values {
		b.Roles = append(b.Roles, values[i])
	}
	return b
}

// WithClusterRoles adds the given value to the ClusterRoles field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the ClusterRoles field.
func (b *UserInfoApplyConfiguration) WithClusterRoles(values ...string) *UserInfoApplyConfiguration {
	for i := range values {
		b.ClusterRoles = append(b.ClusterRoles, values[i])
	}
	return b
}

// WithSubjects adds the given value to the Subjects field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Subjects field.
func (b *UserInfoApplyConfiguration) WithSubjects(values ...v1.Subject) *UserInfoApplyConfiguration {
	for i := range values {
		b.Subjects = append(b.Subjects, values[i])
	}
	return b
}
